include get.e
include wildcard.e
include aUtil.e

function findWords(sequence dictionary, sequence string)
         sequence words

         words = {}
         for i = 1 to length(dictionary) do
             --Check if it matches
             if wildcard_match(string, dictionary[i]) then
                --Add the word to the list
                words = append(words, dictionary[i])
             end if
         end for

         return words
end function

procedure start()
          integer fn
          sequence dictionary, string, words
          object temp

          fn = open("words.txt", "r")
          if fn = -1 then
             puts(2, "Error opening words.txt\n")
             abort(1)
          end if
          dictionary = {}
          while 1 do
                temp = gets(fn)
                if atom(temp) then
                   exit
                end if
                if temp[length(temp)] = '\n' then
                   temp = temp[1..length(temp) - 1]
                end if
                dictionary = append(dictionary, upper(temp))
          end while
          close(fn)
          string = upper(prompt_string("What letters do you know (use '?' for unknown)?\n"))
          words = findWords(dictionary, string)
          --Open the output file
          fn = open("hangman.txt", "w")
          --Check for error
          if fn = -1 then
             --Give an error message
             puts(2, "Error opening hangman.txt\n")
          end if
          --Check if the file was successfully opened
          if fn > -1 then
             --Write a heading to the file
             puts(fn, "Possible words for " & string & ":\n\n")
          end if
          --Write a heading to STDOUT
          puts(1, "Possible words for " & string & ":\n\n")
          --Go through all the words
          for i = 1 to length(words) do
              --Check if the file was successfully opened
              if fn > -1 then
                 --Write the word to the file
                 puts(fn, words[i] & "\n")
              end if
              --Write the word to STDOUT
              puts(1, words[i] & "\n")
          end for
          --Check if the file was successfully opened
          if fn > -1 then
             --Give a message
             puts(1, "Words written to hangman.txt\n")
          end if
end procedure

start()
